diff --git a/sys/dev/misc/evdev/freebsd-bitstring.h b/sys/dev/misc/evdev/freebsd-bitstring.h
index 10fb991e35..1388e2aef2 100644
--- a/sys/dev/misc/evdev/freebsd-bitstring.h
+++ b/sys/dev/misc/evdev/freebsd-bitstring.h
@@ -63,6 +63,7 @@
 #define	_SYS_FREEBSD_BITSTRING_H_
 
 #include <sys/types.h>
+#include <sys/malloc.h>
 
 /*
  * Begin: Ad hoc definitions from FreeBSD sys/sys/types.h
@@ -131,35 +132,33 @@ typedef	unsigned long bitstr_t;
 #define	_BITSTR_MASK (~0UL)
 #define	_BITSTR_BITS (sizeof(bitstr_t) * 8)
 
-#ifdef roundup2
-#define        _bit_roundup2 roundup2
-#else
-#define        _bit_roundup2(x, y)        (((x)+((y)-1))&(~((y)-1))) /* if y is powers of two */
-#endif
+/* round up x to the next multiple of y if y is a power of two */
+#define _bit_roundup2(x, y)						\
+	(((size_t)(x) + (y) - 1) & ~((size_t)(y) - 1))
 
 /* bitstr_t in bit string containing the bit. */
-static inline int
-_bit_idx(int _bit)
+static inline size_t
+_bit_idx(size_t _bit)
 {
 	return (_bit / _BITSTR_BITS);
 }
 
 /* bit number within bitstr_t at _bit_idx(_bit). */
-static inline int
-_bit_offset(int _bit)
+static inline size_t
+_bit_offset(size_t _bit)
 {
 	return (_bit % _BITSTR_BITS);
 }
 
 /* Mask for the bit within its long. */
 static inline bitstr_t
-_bit_mask(int _bit)
+_bit_mask(size_t _bit)
 {
 	return (1UL << _bit_offset(_bit));
 }
 
 static inline bitstr_t
-_bit_make_mask(int _start, int _stop)
+_bit_make_mask(size_t _start, size_t _stop)
 {
 	return ((_BITSTR_MASK << _bit_offset(_start)) &
 	    (_BITSTR_MASK >> (_BITSTR_BITS - _bit_offset(_stop) - 1)));
@@ -167,18 +166,18 @@ _bit_make_mask(int _start, int _stop)
 
 /*----------------------------- Public Interface -----------------------------*/
 /* Number of bytes allocated for a bit string of nbits bits */
-#define	bitstr_size(_nbits) (_bit_roundup2(_nbits, _BITSTR_BITS) / 8)
+#define	bitstr_size(_nbits) (_bit_roundup2((_nbits), _BITSTR_BITS) / 8)
 
 /* Allocate a bit string initialized with no bits set. */
 #ifdef _KERNEL
 static inline bitstr_t *
-bit_alloc(int _nbits, struct malloc_type *type, int flags)
+bit_alloc(size_t _nbits, struct malloc_type *type, int flags)
 {
 	return ((bitstr_t *)kmalloc(bitstr_size(_nbits), type, flags | M_ZERO));
 }
 #else
 static inline bitstr_t *
-bit_alloc(int _nbits)
+bit_alloc(size_t _nbits)
 {
 	return ((bitstr_t *)calloc(bitstr_size(_nbits), 1));
 }
@@ -190,28 +189,56 @@ bit_alloc(int _nbits)
 
 /* Is bit N of bit string set? */
 static inline int
-bit_test(const bitstr_t *_bitstr, int _bit)
+bit_test(const bitstr_t *_bitstr, size_t _bit)
 {
 	return ((_bitstr[_bit_idx(_bit)] & _bit_mask(_bit)) != 0);
 }
 
 /* Set bit N of bit string. */
 static inline void
-bit_set(bitstr_t *_bitstr, int _bit)
+bit_set(bitstr_t *_bitstr, size_t _bit)
 {
 	_bitstr[_bit_idx(_bit)] |= _bit_mask(_bit);
 }
 
 /* clear bit N of bit string name */
 static inline void
-bit_clear(bitstr_t *_bitstr, int _bit)
+bit_clear(bitstr_t *_bitstr, size_t _bit)
 {
 	_bitstr[_bit_idx(_bit)] &= ~_bit_mask(_bit);
 }
 
+/* Are bits in [start ... stop] in bit string all 0 or all 1? */
+static inline int
+bit_ntest(const bitstr_t *_bitstr, size_t _start, size_t _stop, int _match)
+{
+	const bitstr_t *_stopbitstr;
+	bitstr_t _mask;
+
+	_mask = (_match == 0) ? 0 : _BITSTR_MASK;
+	_stopbitstr = _bitstr + _bit_idx(_stop);
+	_bitstr += _bit_idx(_start);
+
+	if (_bitstr == _stopbitstr)
+		return (0 == ((*_bitstr ^ _mask) &
+		    _bit_make_mask(_start, _stop)));
+	if (_bit_offset(_start) != 0 &&
+	    0 != ((*_bitstr++ ^ _mask) &
+	    _bit_make_mask(_start, _BITSTR_BITS - 1)))
+		return (0);
+	if (_bit_offset(_stop) == _BITSTR_BITS - 1)
+		++_stopbitstr;
+	while (_bitstr < _stopbitstr) {
+		if (*_bitstr++ != _mask)
+			return (0);
+	}
+	return (_bit_offset(_stop) == _BITSTR_BITS - 1 ||
+	    0 == ((*_stopbitstr ^ _mask) & _bit_make_mask(0, _stop)));
+}
+
 /* Set bits start ... stop inclusive in bit string. */
 static inline void
-bit_nset(bitstr_t *_bitstr, int _start, int _stop)
+bit_nset(bitstr_t *_bitstr, size_t _start, size_t _stop)
 {
 	bitstr_t *_stopbitstr;
 
@@ -221,16 +248,20 @@ bit_nset(bitstr_t *_bitstr, int _start, int _stop)
 	if (_bitstr == _stopbitstr) {
 		*_bitstr |= _bit_make_mask(_start, _stop);
 	} else {
-		*_bitstr |= _bit_make_mask(_start, _BITSTR_BITS - 1);
-		while (++_bitstr < _stopbitstr)
-	    		*_bitstr = _BITSTR_MASK;
-		*_stopbitstr |= _bit_make_mask(0, _stop);
+		if (_bit_offset(_start) != 0)
+			*_bitstr++ |= _bit_make_mask(_start, _BITSTR_BITS - 1);
+		if (_bit_offset(_stop) == _BITSTR_BITS - 1)
+			++_stopbitstr;
+		while (_bitstr < _stopbitstr)
+			*_bitstr++ = _BITSTR_MASK;
+		if (_bit_offset(_stop) != _BITSTR_BITS - 1)
+			*_stopbitstr |= _bit_make_mask(0, _stop);
 	}
 }
 
 /* Clear bits start ... stop inclusive in bit string. */
 static inline void
-bit_nclear(bitstr_t *_bitstr, int _start, int _stop)
+bit_nclear(bitstr_t *_bitstr, size_t _start, size_t _stop)
 {
 	bitstr_t *_stopbitstr;
 
@@ -240,94 +271,137 @@ bit_nclear(bitstr_t *_bitstr, int _start, int _stop)
 	if (_bitstr == _stopbitstr) {
 		*_bitstr &= ~_bit_make_mask(_start, _stop);
 	} else {
-		*_bitstr &= ~_bit_make_mask(_start, _BITSTR_BITS - 1);
-		while (++_bitstr < _stopbitstr)
-			*_bitstr = 0;
-		*_stopbitstr &= ~_bit_make_mask(0, _stop);
+		if (_bit_offset(_start) != 0)
+			*_bitstr++ &= ~_bit_make_mask(_start, _BITSTR_BITS - 1);
+		if (_bit_offset(_stop) == _BITSTR_BITS - 1)
+			++_stopbitstr;
+		while (_bitstr < _stopbitstr)
+			*_bitstr++ = 0;
+		if (_bit_offset(_stop) != _BITSTR_BITS - 1)
+			*_stopbitstr &= ~_bit_make_mask(0, _stop);
 	}
 }
 
-/* Find the first bit set in bit string at or after bit start. */
-static inline void
-bit_ffs_at(bitstr_t *_bitstr, int _start, int _nbits, int *_result)
+/* Find the first '_match'-bit in bit string at or after bit start. */
+static inline ssize_t
+bit_ff_at_(bitstr_t *_bitstr, size_t _start, size_t _nbits, int _match)
 {
 	bitstr_t *_curbitstr;
 	bitstr_t *_stopbitstr;
+	bitstr_t _mask;
 	bitstr_t _test;
-	int _value, _offset;
+	ssize_t _value;
 
-	if (_nbits > 0) {
-		_curbitstr = _bitstr + _bit_idx(_start);
-		_stopbitstr = _bitstr + _bit_idx(_nbits - 1);
-
-		_test = *_curbitstr;
-		if (_bit_offset(_start) != 0)
-			_test &= _bit_make_mask(_start, _BITSTR_BITS - 1);
-		while (_test == 0 && _curbitstr < _stopbitstr)
-			_test = *(++_curbitstr);
+	if (_start >= _nbits || _nbits <= 0)
+		return (-1);
 
-		_offset = ffsl(_test);
-		_value = ((_curbitstr - _bitstr) * _BITSTR_BITS) + _offset - 1;
-		if (_offset == 0 || _value >= _nbits)
-			_value = -1;
-	} else {
+	_curbitstr = _bitstr + _bit_idx(_start);
+	_stopbitstr = _bitstr + _bit_idx(_nbits - 1);
+	_mask = _match ? 0 : _BITSTR_MASK;
+
+	_test = _mask ^ *_curbitstr;
+	if (_bit_offset(_start) != 0)
+		_test &= _bit_make_mask(_start, _BITSTR_BITS - 1);
+	while (_test == 0 && _curbitstr < _stopbitstr)
+		_test = _mask ^ *(++_curbitstr);
+
+	_value = ((_curbitstr - _bitstr) * _BITSTR_BITS) + ffsl(_test) - 1;
+	if (_test == 0 ||
+	    (_bit_offset(_nbits) != 0 && (size_t)_value >= _nbits))
 		_value = -1;
-	}
-	*_result = _value;
+	return (_value);
 }
+#define bit_ff_at(_bitstr, _start, _nbits, _match, _resultp)		\
+	*(_resultp) = bit_ff_at_((_bitstr), (_start), (_nbits), (_match))
+
+/* Find the first bit set in bit string at or after bit start. */
+#define bit_ffs_at(_bitstr, _start, _nbits, _resultp) \
+	*(_resultp) = bit_ff_at_((_bitstr), (_start), (_nbits), 1)
 
 /* Find the first bit clear in bit string at or after bit start. */
-static inline void
-bit_ffc_at(bitstr_t *_bitstr, int _start, int _nbits, int *_result)
-{
-	bitstr_t *_curbitstr;
-	bitstr_t *_stopbitstr;
-	bitstr_t _test;
-	int _value, _offset;
+#define bit_ffc_at(_bitstr, _start, _nbits, _resultp) \
+	*(_resultp) = bit_ff_at_((_bitstr), (_start), (_nbits), 0)
 
-	if (_nbits > 0) {
-		_curbitstr = _bitstr + _bit_idx(_start);
-		_stopbitstr = _bitstr + _bit_idx(_nbits - 1);
+/* Find the first bit set in bit string. */
+#define bit_ffs(_bitstr, _nbits, _resultp) \
+	*(_resultp) = bit_ff_at_((_bitstr), 0, (_nbits), 1)
 
-		_test = *_curbitstr;
-		if (_bit_offset(_start) != 0)
-			_test |= _bit_make_mask(0, _start - 1);
-		while (_test == _BITSTR_MASK && _curbitstr < _stopbitstr)
-			_test = *(++_curbitstr);
+/* Find the first bit clear in bit string. */
+#define bit_ffc(_bitstr, _nbits, _resultp) \
+	*(_resultp) = bit_ff_at_((_bitstr), 0, (_nbits), 0)
+
+/* Find contiguous sequence of at least size '_match'-bits at or after start */
+static inline ssize_t
+bit_ff_area_at_(bitstr_t *_bitstr, size_t _start, size_t _nbits, size_t _size,
+    int _match)
+{
+	bitstr_t *_curbitstr, _mask, _test;
+	size_t _last, _shft, _maxshft;
+	ssize_t _value;
+
+	if (_start + _size > _nbits || _nbits <= 0)
+		return (-1);
 
-		_offset = ffsl(~_test);
-		_value = ((_curbitstr - _bitstr) * _BITSTR_BITS) + _offset - 1;
-		if (_offset == 0 || _value >= _nbits)
+	_mask = _match ? _BITSTR_MASK : 0;
+	_maxshft = _bit_idx(_size - 1) == 0 ? _size : (int)_BITSTR_BITS;
+	_value = _start;
+	_curbitstr = _bitstr + _bit_idx(_start);
+	_test = ~(_BITSTR_MASK << _bit_offset(_start));
+	for (_last = _size - 1, _test |= _mask ^ *_curbitstr;
+	    !(_bit_idx(_last) == 0 &&
+	    (_test & _bit_make_mask(0, _last)) == 0);
+	    _last -= _BITSTR_BITS, _test = _mask ^ *++_curbitstr) {
+		if (_test == 0)
+			continue;
+		/* Shrink-left every 0-area in _test by maxshft-1 bits. */
+		for (_shft = _maxshft; _shft > 1 && (_test & (_test + 1)) != 0;
+		     _shft = (_shft + 1) / 2)
+			_test |= _test >> _shft / 2;
+		/* Find the start of the first 0-area in _test. */
+		_last = ffsl(~(_test >> 1));
+		_value = (_curbitstr - _bitstr) * _BITSTR_BITS + _last;
+		/* If there's insufficient space left, give up. */
+		if (_value + _size > _nbits) {
 			_value = -1;
-	} else {
-		_value = -1;
+			break;
+		}
+		_last += _size - 1;
+		/* If a solution is contained in _test, success! */
+		if (_bit_idx(_last) == 0)
+			break;
+		/* A solution here needs bits from the next word. */
 	}
-	*_result = _value;
+	return (_value);
 }
+#define bit_ff_area_at(_bitstr, _start, _nbits, _size, _match, _resultp) \
+	*(_resultp) = bit_ff_area_at_(_bitstr, _start, _nbits, _size, _match);
 
-/* Find the first bit set in bit string. */
-static inline void
-bit_ffs(bitstr_t *_bitstr, int _nbits, int *_result)
-{
-	bit_ffs_at(_bitstr, /*start*/0, _nbits, _result);
-}
+/* Find contiguous sequence of at least size set bits at or after start */
+#define bit_ffs_area_at(_bitstr, _start, _nbits, _size, _resultp)	\
+	*(_resultp) = bit_ff_area_at_((_bitstr), (_start), (_nbits), (_size), 1)
 
-/* Find the first bit clear in bit string. */
-static inline void
-bit_ffc(bitstr_t *_bitstr, int _nbits, int *_result)
-{
-	bit_ffc_at(_bitstr, /*start*/0, _nbits, _result);
-}
+/* Find contiguous sequence of at least size cleared bits at or after start */
+#define bit_ffc_area_at(_bitstr, _start, _nbits, _size, _resultp)	\
+	*(_resultp) = bit_ff_area_at_((_bitstr), (_start), (_nbits), (_size), 0)
+
+/* Find contiguous sequence of at least size set bits in bit string */
+#define bit_ffs_area(_bitstr, _nbits, _size, _resultp)			\
+	*(_resultp) = bit_ff_area_at_((_bitstr), 0, (_nbits), (_size), 1)
+
+/* Find contiguous sequence of at least size cleared bits in bit string */
+#define bit_ffc_area(_bitstr, _nbits, _size, _resultp)			\
+	*(_resultp) = bit_ff_area_at_((_bitstr), 0, (_nbits), (_size), 0)
 
 /* Count the number of bits set in a bitstr of size _nbits at or after _start */
-static inline void
-bit_count(bitstr_t *_bitstr, int _start, int _nbits, int *_result)
+static inline ssize_t
+bit_count_(bitstr_t *_bitstr, size_t _start, size_t _nbits)
 {
 	bitstr_t *_curbitstr, mask;
-	int _value = 0, curbitstr_len;
+	size_t curbitstr_len;
+	ssize_t _value = 0;
 
 	if (_start >= _nbits)
-		goto out;
+		return (0);
 
 	_curbitstr = _bitstr + _bit_idx(_start);
 	_nbits -= _BITSTR_BITS * _bit_idx(_start);
@@ -339,6 +413,8 @@ bit_count(bitstr_t *_bitstr, int _start, int _nbits, int *_result)
 		mask = _bit_make_mask(_start, _bit_offset(curbitstr_len - 1));
 		_value += __bitcountl(*_curbitstr & mask);
 		_curbitstr++;
+		if (_nbits < _BITSTR_BITS)
+			return (_value);
 		_nbits -= _BITSTR_BITS;
 	}
 	while (_nbits >= (int)_BITSTR_BITS) {
@@ -351,8 +427,25 @@ bit_count(bitstr_t *_bitstr, int _start, int _nbits, int *_result)
 		_value += __bitcountl(*_curbitstr & mask);
 	}
 
-out:
-	*_result = _value;
+	return (_value);
 }
+#define bit_count(_bitstr, _start, _nbits, _resultp)			\
+	*(_resultp) = bit_count_((_bitstr), (_start), (_nbits))
+
+/* Traverse all set bits, assigning each location in turn to iter */
+#define	bit_foreach_at(_bitstr, _start, _nbits, _iter)			\
+	for ((_iter) = bit_ff_at_((_bitstr), (_start), (_nbits), 1);	\
+	     (_iter) != -1;						\
+	     (_iter) = bit_ff_at_((_bitstr), (_iter) + 1, (_nbits), 1))
+#define	bit_foreach(_bitstr, _nbits, _iter)				\
+	bit_foreach_at(_bitstr, /*start*/0, _nbits, _iter)
+
+/* Traverse all unset bits, assigning each location in turn to iter */
+#define	bit_foreach_unset_at(_bitstr, _start, _nbits, _iter)		\
+	for ((_iter) = bit_ff_at_((_bitstr), (_start), (_nbits), 0);	\
+	     (_iter) != -1;						\
+	     (_iter) = bit_ff_at_((_bitstr), (_iter) + 1, (_nbits), 0))
+#define	bit_foreach_unset(_bitstr, _nbits, _iter)			\
+	bit_foreach_unset_at(_bitstr, /*start*/0, _nbits, _iter)
 
 #endif	/* _SYS_FREEBSD_BITSTRING_H_ */
diff --git a/sys/dev/misc/evdev/input-event-codes.h b/sys/dev/misc/evdev/input-event-codes.h
index 0792a02c41..de148d5d0c 100644
--- a/sys/dev/misc/evdev/input-event-codes.h
+++ b/sys/dev/misc/evdev/input-event-codes.h
@@ -77,9 +77,9 @@
 
 /*
  * Keys and buttons
- */
-
-/*
+ *
+ * Most of the keys/buttons are modeled after USB HUT 1.12
+ * (see http://www.usb.org/developers/hidpage).
  * Abbreviations in the comments:
  * AC - Application Control
  * AL - Application Launch Button
@@ -292,7 +292,8 @@
 #define	KEY_PAUSECD		201
 #define	KEY_PROG3		202
 #define	KEY_PROG4		203
-#define	KEY_DASHBOARD		204	/* AL Dashboard */
+#define	KEY_ALL_APPLICATIONS	204	/* AC Desktop Show All Applications */
+#define	KEY_DASHBOARD		KEY_ALL_APPLICATIONS
 #define	KEY_SUSPEND		205
 #define	KEY_CLOSE		206	/* AC Close */
 #define	KEY_PLAY		207
@@ -453,10 +454,12 @@
 #define	KEY_TITLE		0x171
 #define	KEY_SUBTITLE		0x172
 #define	KEY_ANGLE		0x173
-#define	KEY_ZOOM		0x174
+#define	KEY_FULL_SCREEN		0x174	/* AC View Toggle */
+#define	KEY_ZOOM		KEY_FULL_SCREEN
 #define	KEY_MODE		0x175
 #define	KEY_KEYBOARD		0x176
-#define	KEY_SCREEN		0x177
+#define	KEY_ASPECT_RATIO	0x177	/* HUTRR37: Aspect */
+#define	KEY_SCREEN		KEY_ASPECT_RATIO
 #define	KEY_PC			0x178	/* Media Select Computer */
 #define	KEY_TV			0x179	/* Media Select TV */
 #define	KEY_TV2			0x17a	/* Media Select Cable */
@@ -527,6 +530,9 @@
 #define	KEY_10CHANNELSUP	0x1b8	/* 10 channels up (10+) */
 #define	KEY_10CHANNELSDOWN	0x1b9	/* 10 channels down (10-) */
 #define	KEY_IMAGES		0x1ba	/* AL Image Browser */
+#define	KEY_NOTIFICATION_CENTER	0x1bc	/* Show/hide the notification center */
+#define	KEY_PICKUP_PHONE	0x1bd	/* Answer incoming call */
+#define	KEY_HANGUP_PHONE	0x1be	/* Decline incoming call */
 
 #define	KEY_DEL_EOL		0x1c0
 #define	KEY_DEL_EOS		0x1c1
@@ -554,6 +560,7 @@
 #define	KEY_FN_F		0x1e2
 #define	KEY_FN_S		0x1e3
 #define	KEY_FN_B		0x1e4
+#define	KEY_FN_RIGHT_SHIFT	0x1e5
 
 #define	KEY_BRL_DOT1		0x1f1
 #define	KEY_BRL_DOT2		0x1f2
@@ -618,6 +625,12 @@
 #define	KEY_SCREENSAVER		0x245	/* AL Screen Saver */
 #define	KEY_VOICECOMMAND		0x246	/* Listening Voice Command */
 #define	KEY_ASSISTANT		0x247	/* AL Context-aware desktop assistant */
+#define	KEY_KBD_LAYOUT_NEXT	0x248	/* AC Next Keyboard Layout Select */
+#define	KEY_EMOJI_PICKER	0x249	/* Show/hide emoji picker (HUTRR101) */
+#define	KEY_DICTATE		0x24a	/* Start or Stop Voice Dictation Session (HUTRR99) */
+#define	KEY_CAMERA_ACCESS_ENABLE	0x24b	/* Enables programmatic access to camera devices. (HUTRR72) */
+#define	KEY_CAMERA_ACCESS_DISABLE	0x24c	/* Disables programmatic access to camera devices. (HUTRR72) */
+#define	KEY_CAMERA_ACCESS_TOGGLE	0x24d	/* Toggles the current state of the camera access control. (HUTRR72) */
 
 #define	KEY_BRIGHTNESS_MIN		0x250	/* Set Brightness to Minimum */
 #define	KEY_BRIGHTNESS_MAX		0x251	/* Set Brightness to Maximum */
@@ -660,6 +673,107 @@
  */
 #define	KEY_DATA			0x277
 #define	KEY_ONSCREEN_KEYBOARD		0x278
+/* Electronic privacy screen control */
+#define	KEY_PRIVACY_SCREEN_TOGGLE	0x279
+
+/* Select an area of screen to be copied */
+#define	KEY_SELECTIVE_SCREENSHOT	0x27a
+
+/* Move the focus to the next or previous user controllable element within a UI container */
+#define	KEY_NEXT_ELEMENT		0x27b
+#define	KEY_PREVIOUS_ELEMENT		0x27c
+
+/* Toggle Autopilot engagement */
+#define	KEY_AUTOPILOT_ENGAGE_TOGGLE	0x27d
+
+/* Shortcut Keys */
+#define	KEY_MARK_WAYPOINT		0x27e
+#define	KEY_SOS				0x27f
+#define	KEY_NAV_CHART			0x280
+#define	KEY_FISHING_CHART		0x281
+#define	KEY_SINGLE_RANGE_RADAR		0x282
+#define	KEY_DUAL_RANGE_RADAR		0x283
+#define	KEY_RADAR_OVERLAY		0x284
+#define	KEY_TRADITIONAL_SONAR		0x285
+#define	KEY_CLEARVU_SONAR		0x286
+#define	KEY_SIDEVU_SONAR		0x287
+#define	KEY_NAV_INFO			0x288
+#define	KEY_BRIGHTNESS_MENU		0x289
+
+/*
+ * Some keyboards have keys which do not have a defined meaning, these keys
+ * are intended to be programmed / bound to macros by the user. For most
+ * keyboards with these macro-keys the key-sequence to inject, or action to
+ * take, is all handled by software on the host side. So from the kernel's
+ * point of view these are just normal keys.
+ *
+ * The KEY_MACRO# codes below are intended for such keys, which may be labeled
+ * e.g. G1-G18, or S1 - S30. The KEY_MACRO# codes MUST NOT be used for keys
+ * where the marking on the key does indicate a defined meaning / purpose.
+ *
+ * The KEY_MACRO# codes MUST also NOT be used as fallback for when no existing
+ * KEY_FOO define matches the marking / purpose. In this case a new KEY_FOO
+ * define MUST be added.
+ */
+#define	KEY_MACRO1			0x290
+#define	KEY_MACRO2			0x291
+#define	KEY_MACRO3			0x292
+#define	KEY_MACRO4			0x293
+#define	KEY_MACRO5			0x294
+#define	KEY_MACRO6			0x295
+#define	KEY_MACRO7			0x296
+#define	KEY_MACRO8			0x297
+#define	KEY_MACRO9			0x298
+#define	KEY_MACRO10			0x299
+#define	KEY_MACRO11			0x29a
+#define	KEY_MACRO12			0x29b
+#define	KEY_MACRO13			0x29c
+#define	KEY_MACRO14			0x29d
+#define	KEY_MACRO15			0x29e
+#define	KEY_MACRO16			0x29f
+#define	KEY_MACRO17			0x2a0
+#define	KEY_MACRO18			0x2a1
+#define	KEY_MACRO19			0x2a2
+#define	KEY_MACRO20			0x2a3
+#define	KEY_MACRO21			0x2a4
+#define	KEY_MACRO22			0x2a5
+#define	KEY_MACRO23			0x2a6
+#define	KEY_MACRO24			0x2a7
+#define	KEY_MACRO25			0x2a8
+#define	KEY_MACRO26			0x2a9
+#define	KEY_MACRO27			0x2aa
+#define	KEY_MACRO28			0x2ab
+#define	KEY_MACRO29			0x2ac
+#define	KEY_MACRO30			0x2ad
+
+/*
+ * Some keyboards with the macro-keys described above have some extra keys
+ * for controlling the host-side software responsible for the macro handling:
+ * -A macro recording start/stop key. Note that not all keyboards which emit
+ *  KEY_MACRO_RECORD_START will also emit KEY_MACRO_RECORD_STOP if
+ *  KEY_MACRO_RECORD_STOP is not advertised, then KEY_MACRO_RECORD_START
+ *  should be interpreted as a recording start/stop toggle;
+ * -Keys for switching between different macro (pre)sets, either a key for
+ *  cycling through the configured presets or keys to directly select a preset.
+ */
+#define	KEY_MACRO_RECORD_START		0x2b0
+#define	KEY_MACRO_RECORD_STOP		0x2b1
+#define	KEY_MACRO_PRESET_CYCLE		0x2b2
+#define	KEY_MACRO_PRESET1		0x2b3
+#define	KEY_MACRO_PRESET2		0x2b4
+#define	KEY_MACRO_PRESET3		0x2b5
+
+/*
+ * Some keyboards have a buildin LCD panel where the contents are controlled
+ * by the host. Often these have a number of keys directly below the LCD
+ * intended for controlling a menu shown on the LCD. These keys often don't
+ * have any labeling so we just name them KEY_KBD_LCD_MENU#
+ */
+#define	KEY_KBD_LCD_MENU1		0x2b8
+#define	KEY_KBD_LCD_MENU2		0x2b9
+#define	KEY_KBD_LCD_MENU3		0x2ba
+#define	KEY_KBD_LCD_MENU4		0x2bb
+#define	KEY_KBD_LCD_MENU5		0x2bc
 
 #define	BTN_TRIGGER_HAPPY		0x2c0
 #define	BTN_TRIGGER_HAPPY1		0x2c0
@@ -722,6 +836,16 @@
 #define	REL_DIAL		0x07
 #define	REL_WHEEL		0x08
 #define	REL_MISC		0x09
+/*
+ * 0x0a is reserved and should not be used in input drivers.
+ * It was used by HID as REL_MISC+1 and userspace needs to detect if
+ * the next REL_* event is correct or is just REL_MISC + n.
+ * We define here REL_RESERVED so userspace can rely on it and detect
+ * the situation described above.
+ */
+#define	REL_RESERVED		0x0a
+#define	REL_WHEEL_HI_RES	0x0b
+#define	REL_HWHEEL_HI_RES	0x0c
 #define	REL_MAX			0x0f
 #define	REL_CNT			(REL_MAX+1)
 
@@ -755,9 +879,19 @@
 #define	ABS_TOOL_WIDTH		0x1c
 
 #define	ABS_VOLUME		0x20
+#define	ABS_PROFILE		0x21
 
 #define	ABS_MISC		0x28
 
+/*
+ * 0x2e is reserved and should not be used in input drivers.
+ * It was used by HID as ABS_MISC+6 and userspace needs to detect if
+ * the next ABS_* event is correct or is just ABS_MISC + n.
+ * We define here ABS_RESERVED so userspace can rely on it and detect
+ * the situation described above.
+ */
+#define	ABS_RESERVED		0x2e
+
 #define	ABS_MT_SLOT		0x2f	/* MT slot being modified */
 #define	ABS_MT_TOUCH_MAJOR	0x30	/* Major axis of touching ellipse */
 #define	ABS_MT_TOUCH_MINOR	0x31	/* Minor axis (omit if circular) */
@@ -799,7 +933,8 @@
 #define	SW_LINEIN_INSERT	0x0d  /* set = inserted */
 #define	SW_MUTE_DEVICE		0x0e  /* set = device disabled */
 #define	SW_PEN_INSERTED		0x0f  /* set = pen inserted */
-#define	SW_MAX			0x0f
+#define	SW_MACHINE_COVER	0x10  /* set = cover closed */
+#define	SW_MAX			0x10
 #define	SW_CNT			(SW_MAX+1)
 
 /*
diff --git a/sys/dev/misc/evdev/input.h b/sys/dev/misc/evdev/input.h
index c3f1a07832..b4c0e286d9 100644
--- a/sys/dev/misc/evdev/input.h
+++ b/sys/dev/misc/evdev/input.h
@@ -146,10 +146,11 @@ struct input_keymap_entry {
 /*
  * MT_TOOL types
  */
-#define	MT_TOOL_FINGER		0
-#define	MT_TOOL_PEN		1
-#define	MT_TOOL_PALM		2
-#define	MT_TOOL_MAX		2
+#define	MT_TOOL_FINGER		0x00
+#define	MT_TOOL_PEN		0x01
+#define	MT_TOOL_PALM		0x02
+#define	MT_TOOL_DIAL		0x0a
+#define	MT_TOOL_MAX		0x0f
 
 /*
  * Values describing the status of a force-feedback effect
diff --git a/sys/dev/misc/kbd/atkbd.c b/sys/dev/misc/kbd/atkbd.c
index 96266962db..30b6288d5e 100644
--- a/sys/dev/misc/kbd/atkbd.c
+++ b/sys/dev/misc/kbd/atkbd.c
@@ -40,6 +40,7 @@
 #include <sys/bus.h>
 #include <sys/proc.h>
 #include <sys/malloc.h>
+#include <sys/sysctl.h>
 #include <sys/thread2.h>
 
 #include <sys/kbio.h>
@@ -49,7 +50,17 @@
 
 #include <bus/isa/isareg.h>
 
-static timeout_t	atkbd_timeout;
+static SYSCTL_NODE(_hw, OID_AUTO, atkbd, CTLFLAG_RD, 0, "AT keyboard");
+
+static int atkbdhz = 0;
+
+TUNABLE_INT("hw.atkbd.hz", &atkbdhz);
+SYSCTL_INT(_hw_atkbd, OID_AUTO, hz, CTLFLAG_RW, &atkbdhz, 0,
+    "Polling frequency (in hz)");
+
+
+static void		atkbd_timeout(void *arg);
+static int		atkbd_reset(KBDC kbdc, int flags, int c);
 
 #if 0
 static int atkbd_setmuxmode(KBDC kbdc, int value, int *mux_version);
@@ -164,7 +175,10 @@ atkbd_timeout(void *arg)
 		if (kbd_check_char(kbd))
 			kbd_intr(kbd, NULL);
 	}
-	callout_reset(&kbd->kb_atkbd_timeout_ch, hz / 10, atkbd_timeout, arg);
+	if (atkbdhz > 0) {
+		callout_reset(&kbd->kb_atkbd_timeout_ch, hz / atkbdhz,
+				atkbd_timeout, arg);
+	}
 	crit_exit();
 }
 
@@ -992,6 +1006,38 @@ atkbd_poll(keyboard_t *kbd, int on)
 	return 0;
 }
 
+static int
+atkbd_reset(KBDC kbdc, int flags, int c)
+{
+	/* reset keyboard hardware */
+	if (!(flags & KB_CONF_NO_RESET) && !reset_kbd(kbdc)) {
+		/*
+		 * KEYBOARD ERROR
+		 * Keyboard reset may fail either because the keyboard
+		 * doen't exist, or because the keyboard doesn't pass
+		 * the self-test, or the keyboard controller on the
+		 * motherboard and the keyboard somehow fail to shake hands.
+		 * It is just possible, particularly in the last case,
+		 * that the keyoard controller may be left in a hung state.
+		 * test_controller() and test_kbd_port() appear to bring
+		 * the keyboard controller back (I don't know why and how,
+		 * though.)
+		 */
+		empty_both_buffers(kbdc, 10);
+		test_controller(kbdc);
+		test_kbd_port(kbdc);
+		/*
+		 * We could disable the keyboard port and interrupt... but,
+		 * the keyboard may still exist (see above).
+		 */
+		set_controller_command_byte(kbdc, KBD_KBD_CONTROL_BITS, c);
+		if (bootverbose)
+			kprintf("atkbd: failed to reset the keyboard.\n");
+		return (EIO);
+	}
+	return (0);
+}
+
 /* local functions */
 
 static int
@@ -1165,32 +1211,9 @@ init_keyboard(KBDC kbdc, int *type, int flags)
 	/* default codeset */
 	codeset = -1;
 
-	/* reset keyboard hardware */
-	if (!(flags & KB_CONF_NO_RESET) && !reset_kbd(kbdc)) {
-		/*
-		 * KEYBOARD ERROR
-		 * Keyboard reset may fail either because the keyboard
-		 * doen't exist, or because the keyboard doesn't pass
-		 * the self-test, or the keyboard controller on the
-		 * motherboard and the keyboard somehow fail to shake hands.
-		 * It is just possible, particularly in the last case,
-		 * that the keyoard controller may be left in a hung state.
-		 * test_controller() and test_kbd_port() appear to bring
-		 * the keyboard controller back (I don't know why and how,
-		 * though.)
-		 */
-		empty_both_buffers(kbdc, 10);
-		test_controller(kbdc);
-		test_kbd_port(kbdc);
-		/*
-		 * We could disable the keyboard port and interrupt... but,
-		 * the keyboard may still exist (see above).
-		 */
-		set_controller_command_byte(kbdc, KBD_KBD_CONTROL_BITS, c);
+	if (atkbd_reset(kbdc, flags, c)) {
 		kbdc_lock(kbdc, FALSE);
-		if (bootverbose)
-			kprintf("atkbd: failed to reset the keyboard.\n");
-		return EIO;
+		return (EIO);
 	}
 
 	/* 
diff --git a/sys/dev/misc/kbd/atkbdc.c b/sys/dev/misc/kbd/atkbdc.c
index 1c8d423d17..42d708f075 100644
--- a/sys/dev/misc/kbd/atkbdc.c
+++ b/sys/dev/misc/kbd/atkbdc.c
@@ -104,6 +104,13 @@ static int wait_for_kbd_ack(atkbdc_softc_t *kbdc);
 static int wait_for_aux_data(atkbdc_softc_t *kbdc);
 static int wait_for_aux_ack(atkbdc_softc_t *kbdc);
 
+static int
+atkbdc_getquirks(void)
+{
+	/* TODO */
+	return (0);
+}
+
 atkbdc_softc_t *
 atkbdc_get_softc(int unit)
 {
@@ -222,9 +229,11 @@ atkbdc_setup(atkbdc_softc_t *sc, bus_space_tag_t tag, bus_space_handle_t h0,
 {
 	if (sc->ioh0 == 0) {	/* XXX */
 	    sc->command_byte = -1;
+	    sc->command_mask = 0;
 	    sc->lock = FALSE;
 	    sc->kbd.head = sc->kbd.tail = 0;
 	    sc->aux.head = sc->aux.tail = 0;
+	    sc->aux_mux_enabled = FALSE;
 #if KBDIO_DEBUG >= 2
 	    sc->kbd.call_count = 0;
 	    sc->kbd.qcount = sc->kbd.max_qcount = 0;
@@ -235,6 +244,9 @@ atkbdc_setup(atkbdc_softc_t *sc, bus_space_tag_t tag, bus_space_handle_t h0,
 	sc->iot = tag;
 	sc->ioh0 = h0;
 	sc->ioh1 = h1;
+
+	sc->quirks = atkbdc_getquirks();
+
 	return 0;
 }
 
@@ -548,7 +560,12 @@ write_kbd_command(KBDC p, int c)
 int
 write_aux_command(KBDC p, int c)
 {
-    if (!write_controller_command(p, KBDC_WRITE_TO_AUX))
+    int f;
+
+    f = aux_mux_is_enabled(p) ?
+        KBDC_WRITE_TO_AUX_MUX + kbdcp(p)->aux_mux_port : KBDC_WRITE_TO_AUX;
+
+    if (!write_controller_command(p, f))
 	return FALSE;
     return write_controller_data(p, c);
 }
@@ -1061,6 +1078,20 @@ test_aux_port(KBDC p)
     return c;
 }
 
+int
+kbdc_get_device_mask(KBDC p)
+{
+    return kbdcp(p)->command_mask;
+}
+
+void
+kbdc_set_device_mask(KBDC p, int mask)
+{
+    kbdcp(p)->command_mask =
+	mask & (((p->quirks & KBDC_QUIRK_KEEP_ACTIVATED)
+	    ? 0 : KBD_KBD_CONTROL_BITS) | KBD_AUX_CONTROL_BITS);
+}
+
 int
 get_controller_command_byte(KBDC p)
 {
@@ -1080,26 +1111,14 @@ set_controller_command_byte(KBDC p, int mask, int command)
 	return FALSE;
 
     command = (kbdcp(p)->command_byte & ~mask) | (command & mask);
-#if 0
-    if (mask & KBD_DISABLE_KBD_PORT) {
-	    if (command & KBD_DISABLE_KBD_PORT) {
-		if (!write_controller_command(p, KBDC_DISABLE_KBD_PORT))
-		    return FALSE;
-	    }
+    if (command & KBD_DISABLE_KBD_PORT) {
+	if (!write_controller_command(p, KBDC_DISABLE_KBD_PORT))
+	    return FALSE;
     }
-#endif
     if (!write_controller_command(p, KBDC_SET_COMMAND_BYTE))
 	return FALSE;
     if (!write_controller_data(p, command))
 	return FALSE;
-#if 0
-    if (mask & KBD_DISABLE_KBD_PORT) {
-	    if ((command & KBD_DISABLE_KBD_PORT) == 0) {
-		if (!write_controller_command(p, KBDC_ENABLE_KBD_PORT))
-		    return FALSE;
-	    }
-    }
-#endif
     kbdcp(p)->command_byte = command;
 
     if (verbose)
@@ -1108,3 +1127,78 @@ set_controller_command_byte(KBDC p, int mask, int command)
 
     return TRUE;
 }
+
+/*
+ * Rudimentary support for active PS/2 AUX port multiplexing.
+ * Only write commands can be routed to a selected AUX port.
+ * Source port of data processed by read commands is totally ignored.
+ */
+static int
+set_aux_mux_state(KBDC p, int enabled)
+{
+	int command, version;
+
+	if (write_controller_command(p, KBDC_FORCE_AUX_OUTPUT) == 0 ||
+	    write_controller_data(p, 0xF0) == 0 ||
+	    read_controller_data(p) != 0xF0)
+		return (-1);
+
+	if (write_controller_command(p, KBDC_FORCE_AUX_OUTPUT) == 0 ||
+	    write_controller_data(p, 0x56) == 0 ||
+	    read_controller_data(p) != 0x56)
+		return (-1);
+
+	command = enabled ? 0xa4 : 0xa5;
+	if (write_controller_command(p, KBDC_FORCE_AUX_OUTPUT) == 0 ||
+	    write_controller_data(p, command) == 0 ||
+	    (version = read_controller_data(p)) == command)
+		return (-1);
+
+	return (version);
+}
+
+int
+set_active_aux_mux_port(KBDC p, int port)
+{
+
+	if (!aux_mux_is_enabled(p))
+		return (FALSE);
+
+	if (port < 0 || port >= KBDC_AUX_MUX_NUM_PORTS)
+		return (FALSE);
+
+	kbdcp(p)->aux_mux_port = port;
+
+	return (TRUE);
+}
+
+/* Checks for active multiplexing support and enables it */
+int
+enable_aux_mux(KBDC p)
+{
+	int version;
+
+	version = set_aux_mux_state(p, TRUE);
+	if (version >= 0) {
+		kbdcp(p)->aux_mux_enabled = TRUE;
+		set_active_aux_mux_port(p, 0);
+	}
+
+	return (version);
+}
+
+int
+disable_aux_mux(KBDC p)
+{
+
+	kbdcp(p)->aux_mux_enabled = FALSE;
+
+	return (set_aux_mux_state(p, FALSE));
+}
+
+int
+aux_mux_is_enabled(KBDC p)
+{
+
+	return (kbdcp(p)->aux_mux_enabled);
+}
